<template>
  <div class="product">
    <div class="product_image">
      <NuxtLink :to="serie.url">
        <img
          :src="imageUrl"
          :alt="serie.slug"
          :class="{ product_adult: serie.gender.includes('Adult') }"
        />
        <div
          v-if="serie.gender.includes('Adult')"
          class="product_adult_disclaim"
        >
          18+
        </div>
      </NuxtLink>
      <span
        v-if="serie.banner"
        :class="'product_label text--md product_banner-' + serie.banner"
        >{{ $t('catalog.banner.' + serie.banner) }}</span
      >
    </div>
    <NuxtLink :to="serie.url">
      <div class="product_title">
        <p class="text text--sm text--primary text--bold">
          {{ truncateText(serie.name) }}
        </p>
      </div>
    </NuxtLink>
    <button
      class="button button_sm serie_follow_button"
      :class="{
        button_shape: serie.isfollowing,
        button_full: !serie.isfollowing
      }"
      @click="onFollowClick()"
    >
      {{
        serie.isfollowing ? $t('followers.unfollow') : $t('followers.follow')
      }}
    </button>
  </div>
</template>

<script>
export default {
  name: 'Followserie',
  props: {
    serie: {
      type: Object,
      required: true
    }
  },
  data() {
    return {
      count: 0
    }
  },

  computed: {
    imageUrl() {
      return `${this.$config.izneoUrl}/${this.$i18n.locale}/images/album/${this.serie.ean_last_album}-170or240.jpg?v=${this.serie.version}`
    }
  },
  mounted: function () {
    this.count = this.serie.followers.count
  },

  methods: {
    truncateText(value) {
      let text = value
      if (text.length > 42) {
        text = text.slice(0, 42)
        text =
          text.substr(0, Math.min(text.length, text.lastIndexOf(' '))) + '...'
      }

      return text
    },
    onFollowClick() {
      const elt = this
      if (this.serie.isfollowing) {
        this.axios
          .get('/' + this.$i18n.locale + '/api/unfollow/serie/' + this.serie.id)
          .then(() => {
            elt.serie.isfollowing = false
            elt.serie.followers.count--
            elt.$forceUpdate()
          })
      } else {
        this.axios
          .get('/' + this.$i18n.locale + '/api/follow/serie/' + this.serie.id)
          .then(() => {
            elt.serie.isfollowing = true
            elt.serie.followers.count++
            elt.$forceUpdate()
          })
      }
    }
  }
}
</script>

<style scoped lang="scss">
.product {
  margin: 0px;
  text-align: center;

  @media only screen and (max-width: 767px) {
    margin: 0px 10px;
  }
}

.product_title {
  position: relative;
  h4 {
    position: absolute;
    width: 100%;
    top: 50%;
    transform: translateY(-50%);
  }
}
.product--slider {
  pointer-events: auto !important;
  display: block !important;
}

.serie_follow_button {
  margin: 10px;
  width: 150px;
}

a,
.pagination_page,
.pagination_arrow,
.button,
.filters li {
  cursor: pointer;
}
</style>
